# coding=utf-8
from __future__ import absolute_import

import octoprint.plugin
import re
import json

class ZconfigPlugin(octoprint.plugin.SettingsPlugin,
                    octoprint.plugin.EventHandlerPlugin):

	def get_settings_defaults(self):
		return dict(
			xCoord = -1.0,
			yCoord = -1.0,
			zCoord = -1.0
		)

	def on_event(self, event, payload):
		if not event == "PositionUpdate":
			return
		else:
			self._logger.info(payload)
			coord = re.findall('\d+\.\d+', json.dumps(payload))
			self._logger.info(coord)
			(e, x, y, z) = coord
			self._settings.set(["xCoord"], x)
			self._settings.set(["yCoord"], y)
			self._settings.set(["zCoord"], z)


	def processAtCommand(self, comm_instance, phase, command, parameters, tags=None, *args, **kwargs):
		if command == 'ZCONFIG':
			if parameters == '1':
				self._printer.commands(["G90"])
				self._printer.commands(["G28"])
				self._printer.commands(["M114"])
				self._logger.info("Hey, I'm in the flagCollection 1")
				xCoord = self._settings.get(["xCoord"])
				yCoord = self._settings.get(["yCoord"])
				zCoord = self._settings.get(["zCoord"])
				self._logger.info(xCoord)
				self._logger.info(yCoord)
				self._logger.info(zCoord)
			if parameters == '2':
				self._printer.commands(["G90"])
				self._printer.commands(["G1 X100 Y100"])
				self._printer.commands(["M114"])
				self._logger.info("Hey, I'm in the flagCollection 2")
				xCoord = self._settings.get(["xCoord"])
				yCoord = self._settings.get(["yCoord"])
				zCoord = self._settings.get(["zCoord"])
				self._logger.info(xCoord)
				self._logger.info(yCoord)
				self._logger.info(zCoord)

__plugin_identifier__ = "zconfig"
__plugin_name__ = "Zconfig"
__plugin_pythoncompat__ = ">=2.7,<4" # python 2 and 3

def __plugin_load__():
	global __plugin_implementation__
	__plugin_implementation__ = ZconfigPlugin()

	global __plugin_hooks__
	__plugin_hooks__ = {
		"octoprint.comm.protocol.atcommand.queuing": __plugin_implementation__.processAtCommand
	}